/*
Copyright (C) 2000 Chr. Clemens Lee <clemens@kclee.com>.

This file is part of Jacob - The Java Commando Base
(http://www.kclee.com/clemens/java/javancss/).

Jacob is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

Jacob is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Jacob; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

package jacob;

import ccl.util.*;
import ccl.swing.*;
import java.awt.*;
import java.util.*;
import javax.swing.DefaultListModel;

/**
 * Extends ListCancelSelector, so
 * that it can be created only once,
 * but set again with values, espacially
 * with the class name in the second
 * line of the headline.
 *
 * @author  <a href="http://mats.gmd.de/clemens/">Chr. Clemens Lahme</a> (<a href="mailto:clemens.lahme@mailexcite.com"><i>Clemens.Lahme@mailexcite.com</i></a>)
 * @version $Id: ClassMethodsSelector.java,v 1.7 2000/07/30 15:30:16 clemens Exp clemens $
 */
public class ClassMethodsSelector extends ListCancelMultiSelector {
    public ClassMethodsSelector(Frame frmParent_) {
        super(frmParent_, "Please select the methods which class\n" +
              "''\nshall overwrite.", new Vector(), new Vector());
        setSize(640, 480);
        SwingUtil.centerComponent(this);
    }

    public void set(String sClassName_, Vector vsMethodNames_) {
        Util.panicIf(vsMethodNames_ == null);
        
        _bOK = false;
        
        _alblHeadline[1].setText("'" + sClassName_ + "'");
        
        _vValues = (Vector)vsMethodNames_.clone();
        _vOrigSelected = new Vector();
        _vOrigIndexes = new Vector();
        
        _lst.removeAll();
        for(Enumeration e = _vValues.elements(); e.hasMoreElements(); ) {
            ((DefaultListModel)_lst.getModel()).
                   addElement((String)e.nextElement());
        }
    }
}
