/*
Copyright (C) 2000 Chr. Clemens Lee <clemens@kclee.com>.

This file is part of Jacob - The Java Commando Base
(http://www.kclee.com/clemens/java/javancss/).

Jacob is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

Jacob is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Jacob; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

///////////////////////////////////////////////////////////////
// Program: Jacob
//  Author: Chr. Clemens Lahme
//  Date: 14. 8. 1996
// $Id: Controller.java 1.63 2001/09/08 15:04:32 clemens Exp clemens $
//*************************************************************
// Datei Pfade werden immer mit \ am Ende verwaltet!
////////////////////////////////////////////////////////////////

package jacob;

import ccl.platform.Native;
import ccl.swing.BusyWindow;
import ccl.swing.CCLBorder;
import ccl.swing.HighlightedList;
import ccl.swing.MainJFrame;
import ccl.swing.MemoryDialog;
import ccl.swing.SwingUtil;
import ccl.swing.ThreadsDialog;
import ccl.util.FileUtil;
import ccl.util.Init;
import ccl.util.OutputErrorStreamManager;
import ccl.util.SysEnv;
import ccl.util.Test;
import ccl.util.Util;
import jacob.test.JacobTest;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.border.EmptyBorder;
import javax.swing.plaf.basic.BasicSplitPaneDivider;
import javax.swing.plaf.basic.BasicSplitPaneUI;

public class Controller extends MainJFrame
                        implements KeyListener,
                                   MouseListener,
                                   JacobConstants
{
    private static final String STR_TITLE = "Prj: ";
    private static final String STR_HM_JAVA_LANG_SPEC = "Java Language Spec";

    private static final String S_INIT_SEC_TEXTFILES = "TextFiles";
    private static final String S_INIT_TEXTFILES_FILES = "Files";
    private static final String S_INIT_TEXTFILES_MENUS = "Menus";
    private static final String S_INIT_SEC_TOOLS = "Tools";
    private static final String S_INIT_TOOLS_TOOLS = "Tools";

    private static final String STR_HM_PROJECT_SPEC = "Spec";
    private static final String STR_SPEC_FILE = "psp/spec.txt";
    private static final String STR_HM_MAKEFILE = "Makefile";
    private static final String STR_HM_CREATE_MAKEFILE = "Create &Makefile";
    private static final String STR_HM_CREATE_BUILDFILE = "Create &Ant build.xml";
    private static final String STR_HM_EXPORT_PROJECT = "Export Project File...";
    private static final String STR_HM_NEW_PACKAGE = "Add Package...";
    private static final String STR_HM_DEL_PACKAGE = "Remove Package...";
    private static final String S_ME_NEW_CLASS = "New Class...";
    private static final String STR_HM_ADD_CLASS = "Add Classes...";
    private static final String STR_HM_DEL_CLASS = "Remove Classes...";

    private static final String S_ME_ADD_FILE = "Add File";
    private static final String S_ME_REMOVE_FILE = "Remove File";
    private static final String S_ME_ADD_JAR = "Add Jar";
    private static final String S_ME_REMOVE_JAR = "Remove Jar";

    private static final String S_ME_METHOD_CALLEES = "Method Callees...";
    private static final String S_ME_PROJECT_GREP = "&Search...";
    private static final String S_MENU_TOOLS      = "Tools";
    private static final String S_HM_BEAN_SHELL   = "BeanShell...";
    private static final String S_HM_THREADS      = "Threads...";
    private static final String S_HM_MEMORY       = "Memory...";
    private static final String S_HM_JAVACONSOLE  = "Java Console...";
    private static final String STR_HM_SET_DEPEND = "Set Dependencies...";
    private static final String S_ME_GO_BACK = "Go &Back";
    private static final String S_ME_GO_FORWARD = "Go &Forward";
    private static final String S_ME_ADD_IMPORT = "Add Import Statement";
    private static final String S_ME_ADD_METHOD = "Add Method...";
    private static final String S_ME_ADD_FIELD = "Add Field...";
    private static final String S_ME_RENAME_PACKAGE = "Rename Package...";
    private static final String S_ME_RENAME_CLASS = "Rename Class...";
    private static final String STR_HM_PROJ_SETTINGS = "Project Settings...";
    private static final String STR_HM_PREFERENCES = "&Preferences...";
    private static final String S_FM_UPDATE = "&Update Project";
    private static final String STR_HM_JAVANCSS_ALL = "Javancss All...";
    private static final String STR_HM_JAVANCSS_SEL = "Javancss Selected...";
    private static final String STR_HM_TIMELOG = "Timelog";
    private static final String STR_HM_PSP_PLANNING = "Planning Script";
    private static final String STR_HM_PSP_DEVELOPMENT = "Development Script";
    private static final String STR_HM_PSP_POSTMORTEM = "Postmortem Script";
    private static final String STR_PMN_MAIN_CLASS = "Select as Main Class";

    public static final String STR_PSP_PLANNING = "h:\\eigen\\mad\\process\\psp\\texts\\Planning.txt";
    public static final String STR_PSP_DEVELOPMENT = "h:\\eigen\\mad\\process\\psp\\texts\\Development.txt";
    public static final String STR_PSP_POSTMORTEM = "h:\\eigen\\mad\\process\\psp\\texts\\Postmortem.txt";
    private static final String S_STANDARD_FRAME_WIDTH = "200";
    public static final String S_FRAME_WIDTH = "FrameWidth";
    
    private static final int LIST_SEPARATOR = 2;
    
    private static final int MNU_FILE = 0;
    private static final int MNU_FILE_OPEN = 1;
    private static final int MNU_FILE_SAVE = 2;
    private static final int MNU_FILE_EXIT = 3;
    private static final int MNU_EDIT = 4;
    private static final int MNU_HELP = 5;
    private static final int MNU_HELP_CONTENTS = 6;
    private static final int MNU_HELP_ABOUT = 7;
    private static final int MNU_NUMBER = 8;
    private String[][] _aasMenuString = new String[MNU_NUMBER][2];
    
    private Jacob _pJacob;
    
    private JList _lstPackages;
    private JList _lstClasses;
    private JList _lstMethods;
    private JScrollPane _jspPackages;
    private JScrollPane _jspClasses;
    private JScrollPane _jspMethods;
    
    private JPopupMenu _pPopupMenu = null;
    
    private MethodCalleesDialog _pMethodCalleesDialog;
    
    private JSplitPane _splitInnerTop = null;
    private JSplitPane _splitOuterBottom = null;
    
    private JMenuItem _miGoBack = null;
    private JMenuItem _miGoForward = null;

    private void _setSplitPanesDividerColor() {
        BasicSplitPaneDivider pDividerInner = (BasicSplitPaneDivider)
	    ((BasicSplitPaneUI)_splitInnerTop.getUI()).getDivider();
        pDividerInner.setBackground(getInit().getBackground());
        
        BasicSplitPaneDivider pDivider = (BasicSplitPaneDivider)
               ((BasicSplitPaneUI)_splitOuterBottom.getUI()).getDivider();
		pDivider.setBackground(getInit().getBackground());
    }

    private void _positionAll() {
        // get screen size
        Dimension dimScreenSize = SwingUtil.getScreenSize();
        Util.debug("Controller: _positionAll: dimScreenSize: " + dimScreenSize);

        // get jacob frame width
        int frameWidth = Util.atoi(getInit().getKeyValue(S_FRAME_WIDTH));

        // y location (default 0)
        int yLocation = 0;
        String sYLocation = getInit().getKeyValue( S_INIT_YLOCATION );
        if ( !Util.isEmpty( sYLocation ) ) {
            yLocation = Util.atoi( sYLocation );
            if ( yLocation < 0 || yLocation >= dimScreenSize.height ) {
                yLocation = 0;
            }
        }

        // use screen height for jacob height
        int frameHeight = dimScreenSize.height - yLocation;

        // if init frame height is defined, use it
        String sFrameHeight = getInit().getKeyValue(S_INIT_FRAME_HEIGHT);
        if (!Util.isEmpty(sFrameHeight)) {
            frameHeight = Util.atoi(sFrameHeight);
            if ( frameHeight <= 0 ||
                 frameHeight > dimScreenSize.height - yLocation ) 
            {
                frameHeight = dimScreenSize.height - yLocation;
            }
        }
        Dimension dimFrameSize = new Dimension(frameWidth, frameHeight);
        Util.debug("Controller: _positionAll: dimFrameSize: " + dimFrameSize);
        
        int xPosition = dimScreenSize.width - dimFrameSize.width;
        boolean bLeftSided = Util.atob(getInit().getKeyValue(S_INIT_LEFTSIDED));
        Util.debug("Controller._positionAll().bLeftSided: " + bLeftSided);
        if (bLeftSided) {
            xPosition = 0;
        }
        Util.debug("Controller: _positionAll: xPosition: " + xPosition );
        Util.debug("Controller: _positionAll: location:  " + getLocation() );
        setLocation(xPosition, yLocation);
        Util.debug("Controller: _positionAll: location:  " + getLocation() );
        Util.debug("Controller: _positionAll: size:      " + getSize());
        setSize(dimFrameSize);
        Util.debug("Controller: _positionAll: size:      " + getSize());
        Native n = Native.getInstance();
        n.setLocation( this, xPosition, yLocation );
    }

    private void _initMethodCalleesDialogPosition() {
        Dimension dimScreenSize = SwingUtil.getScreenSize();
        int width = Util.atoi(getInit().getKeyValue(S_FRAME_WIDTH));
        width = width*3/2;
        if (width > dimScreenSize.width) {
            width = dimScreenSize.width;
        }
        int x = dimScreenSize.width - width;
        boolean bLeftSided = Util.atob(getInit().getKeyValue(S_INIT_LEFTSIDED));
        if (bLeftSided) {
            x = 0;
        }
        int height = dimScreenSize.height/2;
        if (height > dimScreenSize.height) {
            height = dimScreenSize.height;
        }
        int y = dimScreenSize.height - height;
        _pMethodCalleesDialog.setBounds(x, y, width, height);
    }

	/**
	 * @param sDir_ Root equals "".
	 */
	private Vector _getTextFiles(String sMenu_) {
		Util.panicIf(sMenu_ == null);

		String sFiles = getInit().getKeyValue(S_INIT_SEC_TEXTFILES,
														  sMenu_ + S_INIT_TEXTFILES_FILES);
		Vector vRetVal = Util.stringToLines(sFiles, '|');

		String sMenus = getInit().getKeyValue(S_INIT_SEC_TEXTFILES,
														  sMenu_ + S_INIT_TEXTFILES_MENUS);
		if (!Util.isEmpty(sMenus)) {
			Vector vMenus = Util.stringToLines(sMenus, '|');
			for(Enumeration eMenus = vMenus.elements();
				 eMenus.hasMoreElements(); )
			{
				String sNextMenu = (String)eMenus.nextElement();
				Vector vNextMenu = _getTextFiles(sNextMenu);
				vNextMenu.insertElementAt(sNextMenu, 0);
				vRetVal.addElement(vNextMenu);
			}
		}

		return vRetVal;
	}

    /**
     * Not the current x location, but calculates the new one.
     */
    public int getXPosition() {
        Dimension dimScreenSize = SwingUtil.getScreenSize();
        int frameWidth = Util.atoi(getInit().getKeyValue(S_FRAME_WIDTH));

        int xPosition = dimScreenSize.width - frameWidth;
        boolean bLeftSided = Util.atob(getInit().getKeyValue(S_INIT_LEFTSIDED));
        if (bLeftSided) {
            xPosition = 0;
        }

        return xPosition;
    }

    public void setListPreferredSize(JList pJList_,
                                         int lines_)
    {
        JComponent jcParent = (JComponent)pJList_.getParent().getParent();
        // 15 = hack
        int listHeight = 15 * lines_ +
               jcParent.getInsets().top + jcParent.getInsets().bottom;
        jcParent.setPreferredSize(new Dimension(jcParent.getPreferredSize().width,
                                                listHeight));
    }

    public void setTitleAndMenuBar() {
        String sTitle = getInit().getFileName();
        setTitle(STR_TITLE + sTitle);
        
        _aasMenuString[MNU_FILE][0] =
               "File";
        _aasMenuString[MNU_FILE][1] =
               "Datei";
        _aasMenuString[MNU_FILE_OPEN][0] =
               "&Open...";
        _aasMenuString[MNU_FILE_OPEN][1] =
               "ffnen...";
        _aasMenuString[MNU_FILE_SAVE][0] =
               "&Save";
        _aasMenuString[MNU_FILE_SAVE][1] =
               "Speichern";
        _aasMenuString[MNU_FILE_EXIT][0] =
               "Exit";
        _aasMenuString[MNU_FILE_EXIT][1] =
               "Beenden";
        _aasMenuString[MNU_EDIT][0] =
               "Edit";
        _aasMenuString[MNU_EDIT][1] =
               "Bearbeiten";
        _aasMenuString[MNU_HELP][0] =
               "Help";
        _aasMenuString[MNU_HELP][1] =
               "Hilfe";
        _aasMenuString[MNU_HELP_CONTENTS][0] =
               "&Contents...";
        _aasMenuString[MNU_HELP_CONTENTS][1] =
               "Inhalt...";
        _aasMenuString[MNU_HELP_ABOUT][0] =
               "About...";
        _aasMenuString[MNU_HELP_ABOUT][1] =
               "Info...";

        int language = 0;

        Vector vMenus = new Vector();
        Vector vFileMenu = new Vector();
        Vector vEditMenu = new Vector();
        Vector vToolsMenu = new Vector();
        Vector vHelpMenu = new Vector();
        Vector vPSPMenu = new Vector();
        
        vFileMenu.addElement(_aasMenuString[MNU_FILE][language]);
        vFileMenu.addElement(_aasMenuString[MNU_FILE_OPEN][language]);
        vFileMenu.addElement(_aasMenuString[MNU_FILE_SAVE][language]);
        vFileMenu.addElement(STR_HM_CREATE_MAKEFILE);
        vFileMenu.addElement(STR_HM_CREATE_BUILDFILE);
        /*vFileMenu.addElement(STR_HM_EXPORT_PROJECT);*/
        vFileMenu.addElement(S_FM_UPDATE);
        vFileMenu.addElement(STR_HM_PREFERENCES);
        vFileMenu.addElement(_aasMenuString[MNU_FILE_EXIT][language]);
        
        // edit menu
        vPSPMenu.addElement((Object)"Psp");
        vPSPMenu.addElement((Object)STR_HM_PSP_PLANNING);
        vPSPMenu.addElement((Object)STR_HM_PSP_DEVELOPMENT);
        vPSPMenu.addElement((Object)STR_HM_PSP_POSTMORTEM);
        
        vEditMenu.addElement(_aasMenuString[MNU_EDIT][language]);
        vEditMenu.addElement( S_ME_GO_BACK );
        vEditMenu.addElement( S_ME_GO_FORWARD );
        vEditMenu.addElement( "---" );
        vEditMenu.addElement(STR_HM_NEW_PACKAGE);
        vEditMenu.addElement(STR_HM_DEL_PACKAGE);
        vEditMenu.addElement(S_ME_NEW_CLASS);
        vEditMenu.addElement(STR_HM_ADD_CLASS);
        vEditMenu.addElement(STR_HM_DEL_CLASS);
        vEditMenu.addElement( "---" );
        vEditMenu.addElement(S_ME_ADD_IMPORT);
        vEditMenu.addElement(S_ME_ADD_FIELD);
        vEditMenu.addElement(S_ME_ADD_METHOD);
        vEditMenu.addElement( S_ME_RENAME_PACKAGE );
        vEditMenu.addElement( S_ME_RENAME_CLASS );
        vEditMenu.addElement(S_ME_PROJECT_GREP);
        vEditMenu.addElement(S_ME_METHOD_CALLEES);
        vEditMenu.addElement( "---" );
        vEditMenu.addElement(STR_HM_SET_DEPEND);
        vEditMenu.addElement(STR_HM_PROJ_SETTINGS);
        vEditMenu.addElement( "---" );
        vEditMenu.addElement( S_ME_ADD_FILE );
        vEditMenu.addElement( S_ME_REMOVE_FILE );
        vEditMenu.addElement( S_ME_ADD_JAR );
        vEditMenu.addElement( S_ME_REMOVE_JAR );
        
        // personal text files
        Vector vTextFiles = _getTextFiles("");
        if (vTextFiles.size() > 0) {
            vEditMenu.addElement("--------");
        }
        vEditMenu = Util.concat(vEditMenu, vTextFiles);
        
        vHelpMenu.addElement(_aasMenuString[MNU_HELP][language]);
        vHelpMenu.addElement(_aasMenuString[MNU_HELP_CONTENTS][language]);
        vHelpMenu.addElement( S_HM_BEAN_SHELL );
        vHelpMenu.addElement(S_HM_THREADS);
        vHelpMenu.addElement(S_HM_MEMORY);
        vHelpMenu.addElement(S_HM_JAVACONSOLE);
        vHelpMenu.addElement((Object)"-----");
        vHelpMenu.addElement(_aasMenuString[MNU_HELP_ABOUT][language]);
        
        vMenus.addElement(vFileMenu);
        vMenus.addElement(vEditMenu);

        // Tools Menu
        // no recursive tool menus yet
        Vector vTools = Util.stringToLines
               (getInit().getKeyValue(S_INIT_SEC_TOOLS,
                                      S_INIT_TOOLS_TOOLS), '|');
        if (vTools.size() <= 0) {
            // so at least we insert javancss tools and
            // some other tools that can distributed anyway
            Init pInit = getInit();
            pInit.setKeyValue(S_INIT_SEC_TOOLS,
                              S_INIT_TOOLS_TOOLS,
                              "Javancss All...|Javancss Selected...|JavaDump|JavaP|List Archive...|Class Dependencies" );
            boolean bError = pInit.setKeyValue
                   (S_INIT_SEC_TOOLS,
                    "Javancss All...",
                    "jacob.tool.JavancssAll");
            Util.debug( "Controller.setTitleAndMenuBar().bError: " +
                        bError );
            pInit.setKeyValue(S_INIT_SEC_TOOLS,
                              "Javancss Selected...",
                              "jacob.tool.JavancssSelected");
            pInit.setKeyValue(S_INIT_SEC_TOOLS,
                              "JavaDump",
                              "jacob.tool.JavaDumpWrapper");
            pInit.setKeyValue(S_INIT_SEC_TOOLS,
                              "JavaP",
                              "jacob.tool.JavaPWrapper");
            pInit.setKeyValue(S_INIT_SEC_TOOLS,
                              "List Archive...",
                              "jacob.tool.ListArchive");
            pInit.setKeyValue(S_INIT_SEC_TOOLS,
                              "Class Dependencies",
                              "jacob.tool.CladepyWrapper");
            vTools = Util.stringToLines
                   (getInit().getKeyValue(S_INIT_SEC_TOOLS,
                                          S_INIT_TOOLS_TOOLS), '|');
        }
        if (vTools.size() > 0) {
            vToolsMenu.addElement(S_MENU_TOOLS);
            for(Enumeration eTools = vTools.elements();
                eTools.hasMoreElements(); )
            {
                String sNextTool = (String)eTools.nextElement();
                vToolsMenu.addElement(sNextTool);
            }
            vMenus.addElement(vToolsMenu);
        } else {
            // there is really something wrong then
            System.out.println( "Jacob error: no <Tools> section found in ini file!" );
        }

        vMenus.addElement(vHelpMenu);
        Util.debug("Controller: setTitleAndMenuBar: vMenus: " + vMenus);
        try {
            setMenuBar(vMenus);
        } catch(ArrayIndexOutOfBoundsException pMenuException) {
            Util.println("\nAn ArrayIndexOutOfBoundsException occured.\n" +
                         "Maybe your initialisation file (for example jacob/jacob.ini)\n" +
                         "seems to be corrupt (espacially in the Tools section).\n" +
                         "If you can't fix it yourself, either run Jacob with the '-debug' option and\n" +
                         "send the standard output to Clemens.Lahme@gmd.de or\n" +
                         "send to the same address your initialisation file\n" +
                         "together with mentioning this error message. Thank you.\n");
            throw pMenuException;
        }

        _miGoBack = _getGoBackMenuItem();
        _miGoForward = _getGoForwardMenuItem();
        setEnabledGoBack( false );
        setEnabledGoForward( false );
    }

    public void init() {
        // Startup Project is jacob.tutorial
        String sFileFullName = getInit().getFileFullName();
        String sFilePath = getInit().getFilePath();
        Init pInit = getInit();
        if (Util.isEmpty(sFileFullName) ||
            !FileUtil.existsDir(sFilePath))
        {
            pInit.setFileFullName(FileUtil.concatPath
                                  (pInit.getApplicationPath(),
                                   "tutorial" +
                                   pInit.getKeyValue(S_INIT_PROJSUFFIX)));
            if (!Util.isEmpty(sFileFullName)) {
                if ( _pJacob.isBatchMode() ) {
                    System.err.println( "Jacob: neither the selected project file\n'" +
                                        sFileFullName +
                                        "'\nnor its directory does exist.\n" );
                    
                    System.exit( 1 );
                }
                SwingUtil.showMessage(this, "Error: neither the selected project file\n'" +
                                    sFileFullName +
                                    "'\nnor its directory does exist.\n" +
                                    "Jacob will open the default tutorial instead.");
            }
        }
        
        _pJacob.loadProject();
        //Util.showLiveSignal();
        
        /*setTitleAndMenuBar();*/
        String sTitle = getInit().getFileName();
        setTitle(STR_TITLE + sTitle);
        
        updateMenu();
        
        /*_pJacob.showClasses(_lstClasses);*/
        _pJacob.showClasses();
        //Util.showLiveSignal();
    }
    
    public Font getDefaultListFont() {
        return new Font( "Dialog", Font.BOLD, 12 );
    }

    private OutputErrorStreamManager _outErrManager = null;

    public Controller(String[] asArgs_, String sInfoHeader_) {
        super(asArgs_, sInfoHeader_);

        _outErrManager = new OutputErrorStreamManager();
        _outErrManager.setAutoClear( false );
        _outErrManager.install();

        Util.debug("Controller.<init>(..).BEGIN");

        SysEnv.initialize();

        Util.debug("Controller.<init>(..).MenuFont: " + UIManager.get("Menu.font"));
        UIManager.put("Menu.font", new Font("Dialog", Font.BOLD, 10));
        UIManager.put("MenuItem.font", new Font("Dialog", Font.BOLD, 10));
        if (isExitSet()) {
            return;
        }

        getInit().setAuthor( "Chr. Clemens Lee" );

        // Jacob self tests?
        Hashtable htOptions = getInit().getOptions();
        if ( htOptions.get( "check" ) != null ) {
            Test pTest = (Test)(new JacobTest());
            pTest.setVerbose( true );
            pTest.setTiming( true );
            pTest.run();
            pTest.printResult( pTest );

            setExit();

            return;
        }

        //Util.showLiveSignal();
        getContentPane().setLayout(new BorderLayout());
        
        // get frame width
        String sFrameWidth = getInit().getKeyValue(S_FRAME_WIDTH);
        if (sFrameWidth == null || sFrameWidth.length() == 0) {
            getInit().setKeyValue(S_FRAME_WIDTH, S_STANDARD_FRAME_WIDTH);
        }
        // get packages list lines
        String sPackagesListLines = getInit().getKeyValue(S_INIT_PLIST_LINES);
        int packagesListLines = 0;
        if (sPackagesListLines != null) {
            packagesListLines = Util.atoi(sPackagesListLines);
        }
        if (packagesListLines < MIN_LIST_LINES ||
            packagesListLines > MAX_LIST_LINES)
        {
            getInit().setKeyValue(S_INIT_PLIST_LINES, S_STANDARD_PLIST_LINES);
            packagesListLines = Util.atoi(S_STANDARD_PLIST_LINES);
        }
        // get classes list lines
        String sClassesListLines = getInit().getKeyValue(S_INIT_CLIST_LINES);
        if (Util.isEmpty(sClassesListLines)) {
            sClassesListLines = new String(S_STANDARD_CLIST_LINES);
            getInit().setKeyValue(S_INIT_CLIST_LINES, S_STANDARD_CLIST_LINES);
        }
        int classesListLines = Util.atoi(sClassesListLines);
        //Util.showLiveSignal();
        
        _pJacob = new Jacob(this, getInit().getArguments());
        
        //Util.showLiveSignal();
        
        _lstPackages = new HighlightedList(new DefaultListModel());
        _lstPackages.setFont( getDefaultListFont() );
        _lstPackages.setBackground(getInit().getListBackground());
        _lstPackages.setForeground(getInit().getListForeground());
        ((HighlightedList)_lstPackages).setHighlight( getInit().getListHighlight() );
        _lstPackages.setSelectionBackground( getInit().getListForeground() );
        _lstPackages.setSelectionForeground( getInit().getListBackground() );        
        _lstPackages.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
        _lstPackages.addMouseListener(this);
        _lstPackages.addKeyListener(this);
        _jspPackages = new JScrollPane(_lstPackages);
        _jspPackages.setBackground(getInit().getBackground());
        _jspPackages.setBorder(new CCLBorder());
        _jspPackages.setMinimumSize(new Dimension(0, 0));
        _jspPackages.setDoubleBuffered(true);
        
        _lstClasses = new HighlightedList(new DefaultListModel());
        _lstClasses.setFont( getDefaultListFont() );
        _lstClasses.setBackground(getInit().getListBackground());
        _lstClasses.setForeground(getInit().getListForeground());
        ((HighlightedList)_lstClasses).setHighlight( getInit().getListHighlight() );
        _lstClasses.setSelectionBackground( getInit().getListForeground() );
        _lstClasses.setSelectionForeground( getInit().getListBackground() );        
        _lstClasses.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
        _lstClasses.addMouseListener(this);
        _lstClasses.addKeyListener(this);
        _jspClasses = new JScrollPane(_lstClasses);
        _jspClasses.setBackground(getInit().getBackground());
        _jspClasses.setBorder(new CCLBorder());
        _jspClasses.setMinimumSize(new Dimension(0, 0));
        _jspClasses.setDoubleBuffered(true);
        
        _lstMethods = new HighlightedList(new DefaultListModel());
        _lstMethods.setFont( getDefaultListFont() );
        _lstMethods.addMouseListener(this);
        _lstMethods.addKeyListener(this);
        _lstMethods.setBackground(getInit().getListBackground());
        _lstMethods.setForeground(getInit().getListForeground());
        ((HighlightedList)_lstMethods).setHighlight( getInit().getListHighlight() );
        _lstMethods.setSelectionBackground( getInit().getListForeground() );
        _lstMethods.setSelectionForeground( getInit().getListBackground() );        
        _lstMethods.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
        _jspMethods = new JScrollPane(_lstMethods);
        _jspMethods.setBackground(getInit().getBackground());
        _jspMethods.setBorder(new CCLBorder());
        _jspMethods.setMinimumSize(new Dimension(0, 0));
        _jspMethods.setDoubleBuffered(true);
        
        // inner splitpane ------------------------------------------
        EmptyBorder pEmptyBorderInner = new EmptyBorder(0, 0, 0, 0);
        
        _splitInnerTop = new JSplitPane(JSplitPane.VERTICAL_SPLIT,
                                        _jspPackages, _jspClasses);
        _splitInnerTop.setBorder(pEmptyBorderInner);
        _splitInnerTop.setDividerSize(LIST_SEPARATOR);
        /*_splitInnerTop.setOneTouchExpandable( true );*/
        
        // outer splitpane --------------------------------------------
        EmptyBorder pEmptyBorderOuter = new EmptyBorder(0, 0, 0, 0);
        
        _splitOuterBottom = new JSplitPane(JSplitPane.VERTICAL_SPLIT,
                                           _splitInnerTop, _jspMethods);
        _splitOuterBottom.setBorder(pEmptyBorderOuter);
        _splitOuterBottom.setDividerSize(LIST_SEPARATOR);
        /*_splitOuterBottom.setOneTouchExpandable( true );*/

        _setSplitPanesDividerColor();
        /*if (Util.isOSWindows()) {
          _jspPackages.setDoubleBuffered(false);
          _jspClasses.setDoubleBuffered(false);
          _jspMethods.setDoubleBuffered(false);
          _splitOuterBottom.setDoubleBuffered(true);
          }*/
        
        getContentPane().add(_splitOuterBottom, BorderLayout.CENTER);
        

        // Positionieren
        _pMethodCalleesDialog = new MethodCalleesDialog(this);
        _initMethodCalleesDialogPosition();
        
        setTitleAndMenuBar();
        _positionAll();
        addKeyListener(this);
        
        /*JMenuItem pJMenuItem = new JMenuItem("Test");
          _pJPopupMenu.add(pJMenuItem);
          pJMenuItem.addActionListener(this);
          JMenuItem pJMenuItem2 = new JMenuItem("Test2");
          _pJPopupMenu.add(pJMenuItem2);
          pJMenuItem2.addActionListener(this);*/
        /*add(_pPopupMenu);*/
        /*_lstPackages.enableEvents(AWTEvent.MOUSE_EVENT_MASK);
          _lstClasses.enableEvents(AWTEvent.MOUSE_EVENT_MASK);
          _lstMethods.enableEvents(AWTEvent.MOUSE_EVENT_MASK);
          enableEvents(AWTEvent.MOUSE_EVENT_MASK);*/
        /*_lstMethods.addMouseListener(this);*/

	_pPopupMenu = new JPopupMenu();
	JMenuItem mnuMainClass = new JMenuItem( STR_PMN_MAIN_CLASS );
	mnuMainClass.addActionListener( this );
	_pPopupMenu.add( mnuMainClass );
	_lstClasses.addMouseListener( new PopupListener() );
	
        init();

        if ( getInit().getOptions().get( S_OPT_CREATEMAKEFILE ) != null ) {
            System.out.println( "jacob: creating makefile '" +
                                FileUtil.concatPath( getInit().getFilePath(),
                                                     "Makefile" ) + "'" );
            _pJacob.createMakefile();
            System.out.println( "done." );

            // system exit should happen somewhere else actually, but, so what?
            System.exit( 0 );
        }
        if ( getInit().getOptions().get( S_OPT_CREATEJAR ) != null ) {
            System.out.println( "jacob: creating jar file '" +
                                FileUtil.concatPath
                                ( getInit().getFilePath(),
                                  "lib" + File.separator +
                                  getInit().getFileName().
                                  toLowerCase() + ".jar" ) + 
                                "'" );
            _pJacob.createJar();
            Util.println( "done." );

            // system exit should happen somewhere else actually, but, so what?
            System.exit( 0 );
        }
        if ( getInit().getOptions().get( S_OPT_CREATEAPIDOC ) != null ) {
            System.out.println( "jacob: creating apidoc in directory '" +
                                FileUtil.concatPath
                                ( getInit().getFilePath(),
                                  "doc" + File.separator +
                                  "api" ) + 
                                "'" );
            _pJacob.createAPIDoc();
            Util.println( "done." );

            // system exit should happen somewhere else actually, but, so what?
            System.exit( 0 );
        }

        setVisible(true);
        
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                _positionAll();
                Util.sleep( 3 );
                _positionAll();
            }
        });
        
        Util.debug("Controller.<init>(..).END");
    }
    
    public void setBackground(Color clrBackground_) {
        super.setBackground(clrBackground_);
        try {
            if (!(getInit().getBackground().equals(clrBackground_))) {
                getInit().setBackground(clrBackground_);
            }
            _jspPackages.setBackground(clrBackground_);
            _jspClasses.setBackground(clrBackground_);
            _jspMethods.setBackground(clrBackground_);
            _setSplitPanesDividerColor();
        } catch(NullPointerException pNullPointerException) {
            // happens when JFrame initializes itself
        }
    }
    
    public void setListBackground(Color clrListBackground_) {
        _lstPackages.setBackground(clrListBackground_);
        _lstClasses.setBackground(clrListBackground_);
        _lstMethods.setBackground(clrListBackground_);
        if (!(getInit().getListBackground().equals(clrListBackground_))) {
            getInit().setListBackground(clrListBackground_);
        }
    }
    
    public void setListForeground(Color clrListForeground_) {
        _lstPackages.setForeground(clrListForeground_);
        _lstClasses.setForeground(clrListForeground_);
        _lstMethods.setForeground(clrListForeground_);
        if (!(getInit().getListForeground().equals(clrListForeground_))) {
            getInit().setListForeground(clrListForeground_);
        }
    }
    
    /**
     * Browser list items that were once selected get
     * highlighted. S.J. Dick's idea.
     */
    public void setListHighlight( Color clrListHighlight_ ) {
        ((HighlightedList)_lstPackages).
               setHighlight( clrListHighlight_ );
        ((HighlightedList)_lstClasses).
               setHighlight( clrListHighlight_ );
        ((HighlightedList)_lstMethods).
               setHighlight( clrListHighlight_ );
        if ( !(getInit().getListHighlight().equals( clrListHighlight_ ) ) ) {
            getInit().setListHighlight( clrListHighlight_ );
        }
    }
    
    public JList getPackagesList() {
        return _lstPackages;
    }
    
    public JList getClassesList() {
        return _lstClasses;
    }
    
    public JList getMethodsList() {
        return _lstMethods;
    }
    
    public void resetToPreferredListSizes() {
        _splitOuterBottom.resetToPreferredSizes();
        _splitInnerTop.resetToPreferredSizes();
        repaint();
    }
    
    /**
     * @return   true   if exit is ok.
     */
    public boolean exit() {
        Vector vRunningTools = _pJacob.getRunningTools();
        if (vRunningTools.size() > 0) {
            // trick, if null has been returned, then cancel was pressed
            String sSelection = SwingUtil.inputListCancel(this, "Warning: The following tools are still running.\n" +
                                                        "You should quit them before leaving Jacob.\n" +
                                                        "If you proceed you risk to loose some of your applications' data.",
                                                        vRunningTools);
            requestFocus();
            if ( sSelection == null ) {
                return false;
            }
        }
        Util.debug("Controller.exit().1");

        _pJacob.exit();

        boolean bExit = super.exit();

        if ( bExit ) {
            _outErrManager.deinstall();
        }

        return bExit;
    }
    
    private Runnable _thrMenu = null;
    
    class AddPackage implements Runnable {
        public void run() {
            _pJacob.addPackage();
        }
    }
    
    /*class ExportProject implements Runnable {
        public void run() {
            _pJacob.exportProjectFile();
        }
        }*/
    
    class CreateMakefile implements Runnable {
        public void run() {
            _pJacob.createMakefile();
        }
    }
    
    class CreateBuildfile implements Runnable {
        public void run() {
            _pJacob.createBuildfile();
        }
    }
    
    class OpenProject implements Runnable {
        public void run() {
            Util.debug("Controller.OpenProject.run().1");
            _pJacob.openProject();
        }
    }
    
    class RemovePackage implements Runnable {
        public void run() {
            _pJacob.removePackage();
        }
    }
    
    class NewClass implements Runnable {
        public void run() {
            try {
                _pJacob.createNewClass();
            } catch( Throwable throwable ) {
                Util.printlnErr( Util.getStackTrace( throwable ) );
            }
        }
    }
    
    class AddClasses implements Runnable {
        public void run() {
            _pJacob.addClasses();
        }
    }
    
    class SetDependencies implements Runnable {
        public void run() {
            _pJacob.setClassDependencies();
        }
    }
    
    class RemoveClasses implements Runnable {
        public void run() {
            _pJacob.removeClasses();
        }
    }
    
    class ProjectSettings implements Runnable {
        public void run() {
            _pJacob.changeProjectSettings();
        }
    }
    
    class Preferences implements Runnable {
        public void run() {
            _pJacob.changePreferences();
        }
    }
    
    class Parse implements Runnable {
        public void run() {
            _pJacob.parse();
        }
    }
    
    class Save implements Runnable {
        public void run() {
            _pJacob.save();
        }
    }
    
    class BeanShell implements Runnable {
        public void run() {
            bsh.Console.main( new String[ 0 ] );
        }
    }
    
    class ShowMemory implements Runnable {
        public void run() {
            MemoryDialog pMemoryDialog = new MemoryDialog( Controller.this );
            //pMemoryDialog.setVisible( true );
            //pMemoryDialog.show();
        }
    }
    
    class ShowJavaConsole implements Runnable {
        public void run() {
            JavaConsole javaConsole = new JavaConsole( Controller.this, _outErrManager );
            javaConsole.setVisible( true );
        }
    }
    
    class ShowThreads implements Runnable {
        public void run() {
            new ThreadsDialog(Controller.this);
        }
    }
    
    class UpdateProject implements Runnable {
        public void run() {
            _pJacob.updateProject();
        }
    }
    
    class RunTool implements Runnable {
        String _sMenuItem = null;
        
        public void set(String sMenuItem_) {
            _sMenuItem = sMenuItem_;
        }
        
        public void run() {
            Util.debug( this, "run()._sMenuItem: '" + _sMenuItem + "'" );
            String sTool = getInit().getKeyValue
                   (S_INIT_SEC_TOOLS, _sMenuItem);
            if ( Util.isEmpty( sTool ) ) {
                SwingUtil.showMessage( Controller.this,
                                       "Error: can't find any class for tool " 
                                       + _sMenuItem
                                       + ".\nMaybe the initialization file where this class\nshould be specified is corrupt?!" );

                return;
            }
            try {
                _pJacob.runTool(sTool);
            } catch(Exception pException) {
                SwingUtil.showMessage(Controller.this, "Error: In order to use tool\n'" +
                                    _sMenuItem + "'\nit was necessary to load and run class\n'" +
                                    sTool + "'.\nUnfortunately this failed. Here is the exception:\n" +
                                    pException);
            }
        }
    }
    
    public class ParseMethodCallees implements Runnable {
        public void run() {
            String sMethod = null;
            int index = _lstMethods.getSelectedIndex();
            if (index != -1) {
                sMethod = _lstMethods.getSelectedValue().toString();
            }
            _pJacob.parseMethodCallees(sMethod);
            Runnable runTemp = new Runnable() {
                public void run() {
                    _pMethodCalleesDialog.setMethodCallees
                           (_pJacob.getMethodCallees());
                }
            };
            SwingUtilities.invokeLater(runTemp);
        }
    }
    
    public class ShowMethodCallees implements Runnable {
        public void run() {
            Runnable runTemp = new Runnable() {
                public void run() {
                    if (_pMethodCalleesDialog.isVisible() == false) {
                        _pMethodCalleesDialog.setVisible(true);
                    }
                    //_pMethodCalleesDialog.setPosition();
                    _pMethodCalleesDialog.toFront();
                    _pMethodCalleesDialog.requestFocus();
                }
            };
            SwingUtilities.invokeLater(runTemp);
            SwingUtilities.invokeLater
                   (new Runnable() {
                       public void run() {
                           _pMethodCalleesDialog.setPosition();
                       }
                   });
        }
    }
    
    public class EditMethodCallee implements Runnable {
        private String _sMethod = null;
        

        public EditMethodCallee(String sMethod_) {
            super();
            _sMethod = sMethod_;
        }
        
        public void run() {
            SwingUtil.invokeLaterIfNecessary( new Runnable() {
                public void run() {
                    _pJacob.editMethodCallee(_sMethod);
                    _pJacob.selectMethod(_sMethod);
                }
            } );
        }
    }

    class AddImportStatement implements Runnable {
        public void run() {
            _pJacob.addImportStatement();
        }
    }

    class AddMethod implements Runnable {
        public void run() {
            _pJacob.addMethod();
        }
    }

    class AddField implements Runnable {
        public void run() {
            _pJacob.addField();
        }
    }

    class RenameClass implements Runnable {
        public void run() {
            _pJacob.renameClass();
        }
    }

    class RenamePackage implements Runnable {
        public void run() {
            _pJacob.renamePackage();
        }
    }

    class GoBack implements Runnable {
        public void run() {
            _pJacob.goBack();
        }
    }

    class GoForward implements Runnable {
        public void run() {
            _pJacob.goForward();
        }
    }

    class ProjectGrep implements Runnable {
        public void run() {
            _pJacob.grepOnProject();
        }
    }

    class AddFile implements Runnable {
        public void run() {
            _pJacob.addResource();
        }
    }

    class RemoveFile implements Runnable {
        public void run() {
            _pJacob.removeResource();
        }
    }

    class AddJar implements Runnable {
        public void run() {
            _pJacob.addJar();
        }
    }

    class RemoveJar implements Runnable {
        public void run() {
            _pJacob.removeJar();
        }
    }

    public void runHook() {
        super.runHook();
        if (_thrMenu != null) {
            try {
                _thrMenu.run();
            } catch(Exception pException) {
                Util.debug("Controller.runHook()._thrMenu: " + _thrMenu);
                Util.debug("Controller.runHook().pException: " + pException);
                pException.printStackTrace();
            }
            _thrMenu = null;
        }
    }
    
    public void actionPerformed(ActionEvent pActionEvent_) {
        Object oSource = pActionEvent_.getSource();
        Util.debug("Controller.actionPerformed(..).oSource: " + oSource);
        Util.debug("Controller.actionPerformed(..)._thrMenu: " + _thrMenu);
        if (_thrMenu != null) {
            return;
        }
        if (oSource instanceof JMenuItem) {
            String sMenuItem = ((JMenuItem)oSource).getText();
            String sActionCommand = pActionEvent_.getActionCommand();
            Util.debug( "Controller.actionPerformed(..).sActionCommand: " +
                        sActionCommand );
            int language = 0;
            Util.debug("Controller.actionPerformed(..).sMenuItem: " + sMenuItem);
            Util.debug("Controller.actionPerformed(..).language: " + language);
            if (sActionCommand.equals(_aasMenuString[MNU_FILE_OPEN][language])) {
                Util.debug("Controller.actionPerformed(..).FILE_OPEN");
                _thrMenu = new OpenProject();
                Util.debug("Controller.actionPerformed(..)._thrMenu: " + _thrMenu);
            } else if (sActionCommand.equals(_aasMenuString[MNU_FILE_SAVE][language]) ||
                       sMenuItem.equals(_aasMenuString[MNU_FILE_SAVE][language])) 
            {
                _thrMenu = new Save();
            } else if ( sActionCommand.equals( STR_HM_CREATE_MAKEFILE ) ) {
                _thrMenu = new CreateMakefile();
            } else if ( sActionCommand.equals( STR_HM_CREATE_BUILDFILE ) ) {
                _thrMenu = new CreateBuildfile();
            } else if ( sActionCommand.equals( S_ME_GO_BACK ) ) {
                _thrMenu = new GoBack();
            } else if ( sActionCommand.equals( S_ME_GO_FORWARD ) ) {
                _thrMenu = new GoForward();
            } else if (sMenuItem.equals(STR_HM_NEW_PACKAGE)) {
                _thrMenu = new AddPackage();
            } else if (sMenuItem.equals(STR_HM_DEL_PACKAGE)) {
                _thrMenu = new RemovePackage();
            } else if (sMenuItem.equals(S_ME_NEW_CLASS)) {
                _thrMenu = new NewClass();
            } else if (sMenuItem.equals(STR_HM_ADD_CLASS)) {
                _thrMenu = new AddClasses();
            } else if (sMenuItem.equals(STR_HM_DEL_CLASS)) {
                _thrMenu = new RemoveClasses();
            } else if (sMenuItem.equals(S_ME_METHOD_CALLEES)) {
                _thrMenu = new ShowMethodCallees();
            } else if (sActionCommand.equals(S_ME_PROJECT_GREP)) {
                _thrMenu = new ProjectGrep();
            } else if (sMenuItem.equals(S_ME_ADD_IMPORT)) {
                _thrMenu = new AddImportStatement();
                interrupt();
            } else if (sMenuItem.equals(S_ME_ADD_METHOD)) {
                _thrMenu = new AddMethod();
                interrupt();
            } else if (sMenuItem.equals(S_ME_ADD_FIELD)) {
                _thrMenu = new AddField();
                interrupt();
            } else if (sMenuItem.equals( S_ME_RENAME_PACKAGE )) {
                _thrMenu = new RenamePackage();
                interrupt();
            } else if (sMenuItem.equals( S_ME_RENAME_CLASS )) {
                _thrMenu = new RenameClass();
                interrupt();
            } else if (sMenuItem.equals(STR_HM_SET_DEPEND)) {
                _thrMenu = new SetDependencies();
            } else if (sMenuItem.equals(STR_HM_PROJ_SETTINGS)) {
                _thrMenu = new ProjectSettings();
            } else if ( sMenuItem.equals( S_ME_ADD_FILE ) ) {
                _thrMenu = new AddFile();
            } else if ( sMenuItem.equals( S_ME_REMOVE_FILE ) ) {
                _thrMenu = new RemoveFile();
            } else if ( sMenuItem.equals( S_ME_ADD_JAR ) ) {
                _thrMenu = new AddJar();
                interrupt();
            } else if ( sMenuItem.equals( S_ME_REMOVE_JAR ) ) {
                _thrMenu = new RemoveJar();
                interrupt();
            } else if (sActionCommand.equals(STR_HM_PREFERENCES)) {
                _thrMenu = new Preferences();
            } else if ( sMenuItem.equals( S_HM_BEAN_SHELL ) ) {
                BeanShell pBeanShell = new BeanShell();
                new Thread( pBeanShell ).start();
            } else if (sMenuItem.equals(S_HM_THREADS)) {
                _thrMenu = new ShowThreads();
                interrupt();
            } else if (sMenuItem.equals(S_HM_MEMORY)) {
                _thrMenu = new ShowMemory();
                interrupt();
            } else if (sMenuItem.equals(S_HM_JAVACONSOLE)) {
                _thrMenu = new ShowJavaConsole();
                interrupt();
            } else if ( sMenuItem.equals( STR_PMN_MAIN_CLASS ) ) {
		_pJacob.setMainClass();
            } else if (sActionCommand.equals(S_FM_UPDATE)) {
                _thrMenu = new UpdateProject();
            } else if ('1' <= sMenuItem.charAt(0) && sMenuItem.charAt(0) <= '9') {
                Util.debug("Controller: actionPerformed: sMenuItem: " + sMenuItem);
                _pJacob.openOldProject(sMenuItem.substring(sMenuItem.indexOf(' ') + 1,
                                                           sMenuItem.length()));
                interrupt();

                return;
            } else {
                // tool ?
                JMenu mnTools = getJMenuBar().getMenu(2);
                JPopupMenu pmnParent = (JPopupMenu)((JMenuItem)oSource).getParent();
		/*Util.debug("Controller.actionPerformed(..).mncnParent: " + mncnParent);
                  Util.debug("Controller.actionPerformed(..).((JMenuItem)oSource).getSubElements(): " + ((JMenuItem)oSource).getSubElements());
                  Util.debug("Controller.actionPerformed(..).((JMenuItem)oSource).getSubElements().length: " + ((JMenuItem)oSource).getSubElements().length);
                  Util.debug("Controller.actionPerformed(..).((JMenuItem)oSource).getSubElements()[0]: " + (((JMenuItem)oSource).getSubElements())[0]);*/
                if (pmnParent == mnTools.getPopupMenu()) {
                    Util.debug("Controller.actionPerformed(..).TOOL");
                    _thrMenu = new RunTool();
                    ((RunTool)_thrMenu).set(sMenuItem);
                } else {
                    // then it should be custom edit files
                    String sFilename = getInit().getKeyValue(S_INIT_SEC_TEXTFILES,
                                                             sMenuItem);
                    if (!Util.isEmpty(sFilename)) {
                        sFilename = sFilename.replace('/', File.separatorChar);
                        if (sFilename.charAt(0) == '.') {
                            sFilename = FileUtil.getAbsoluteFileName
                                   (FileUtil.concatPath(getInit().getFilePath(), sFilename));
                        }
                        _pJacob.editFile(sFilename);
                    }
                }
            } // end if instanceof menu item
            interrupt();
        } else if (oSource instanceof JButton) {
            String sLabel = ((JButton)oSource).getText();
            if (sLabel.equals(S_PARSE)) {
				// erst mal nur zum entwickeln nach stdout alles
                _thrMenu = new ParseMethodCallees();
            }
            interrupt();
        }
        
        super.actionPerformed(pActionEvent_);
    }
    
    // -------------------------------------------------------------
    // KeyEvent Funktionen
    // -------------------------------------------------------------
    
    public void keyTyped(KeyEvent e) {
    }
    
    public void keyPressed(KeyEvent pKeyEvent_) {
        Object oSource = pKeyEvent_.getSource();
        int keyCode = pKeyEvent_.getKeyCode();
        Util.debug("Controller.keyPressed(): keyCode: " + keyCode);
        Util.debug("Controller.keyPressed(): oSource: " + oSource);
        if (keyCode == KeyEvent.VK_ENTER) {
            if (oSource == _lstPackages) {
                _pJacob.showClasses();
                _pJacob.showMethods();
            } else if (oSource == _lstClasses) {
                _pJacob.showMethods();
                _pJacob.editClass();
            } else if (oSource == _lstMethods) {
                String sSelectedItem = _lstMethods.getSelectedValue().toString();
                if (!Util.isEmpty(sSelectedItem)) {
                    if (sSelectedItem.equals(S_PARSE)) {
                        _pJacob.parse();
                        _pJacob.showMethods();
                    } else {
                        _pJacob.editMethod(sSelectedItem);
                    }
                }
            } else {
		// it must come from the Method Callees list
                if (_thrMenu == null) {
                    Util.debug("Controller.keyPressed(..).CALLEES");
                    _thrMenu = new EditMethodCallee(_pMethodCalleesDialog.getSelectedMethod());
                    //((EditMethodCallee)_thrMenu).set();
                    interrupt();
                }
            }
        }
        if (keyCode == KeyEvent.VK_TAB) {
            Util.debug("Controller: keyPressed: tab");
            _lstPackages.requestFocus();
        }
    }
    
    public void keyReleased(KeyEvent e) {
    }

    public void mouseClicked(MouseEvent pMouseEvent_) {
        Util.debug("Controller.mouseClicked(..).pMouseEvent_: " + pMouseEvent_);
    }
    
    public void mouseEntered(MouseEvent pMouseEvent_) {
        /*Util.debug("Controller.mouseEntered(..).pMouseEvent_: " + pMouseEvent_);*/
    }
    
    public void mouseExited(MouseEvent pMouseEvent_) {
        /*Util.debug("Controller.mouseExited(..).pMouseEvent_: " + pMouseEvent_);*/
    }

    public void mouseReleased(MouseEvent pMouseEvent_) {
        Util.debug("Controller.mouseReleased(..).pMouseEvent_: " + pMouseEvent_);
        
        Object oSource = pMouseEvent_.getSource();

        // right mouse button
        if ((pMouseEvent_.getModifiers() & Event.META_MASK) == Event.META_MASK) {
            Util.debug("Controller.mouseReleased(..).RIGHT_MOUSE");
            if (_thrMenu != null) {
                Util.debug("Controller.mouseReleased(..).MENU_IN_PROCESS");
                return;
            }
            
            if ( oSource == _lstClasses ) {
                // select list item
                int listIndex = _lstClasses.locationToIndex
                       ( pMouseEvent_.getPoint() );
                _lstClasses.setSelectedIndex( listIndex );
                _pJacob.showMethods();
                // explicitly no editClass() now!

                return;
            }

            // method selected?
            if ( oSource == _lstMethods ) {
                // select list item
                int listIndex = _lstMethods.locationToIndex
                       ( pMouseEvent_.getPoint() );
                _lstMethods.setSelectedIndex( listIndex );
                String sSelectedMethod = _pJacob.getSelectedMethod();
                if (Util.isEmpty(sSelectedMethod)) {
                    Util.debug("Controller.mouseReleased(..).NO_METHOD_SELECTED");
                    return;
                }
            
                Util.debug("Controller.mouseReleased(..).STILL_THERE");
                _thrMenu = new ShowMethodCallees();
            
                interrupt();
            
                return;
            }
                /*JPopupMenu pJPopupMenu = new JPopupMenu();
              
                  JMenuItem pJMenuItem = new JMenuItem(S_PARSE);
              pJMenuItem.addActionListener(this);
              pJPopupMenu.add(pJMenuItem);
              Vector vMethodCallees = _pJacob.getMethodCallees();
              for(Enumeration eCallees = vMethodCallees.elements();
              eCallees.hasMoreElements(); )
              {
              String sMethodCallee = (String)eCallees.nextElement();
              JMenuItem miNext = new JMenuItem(sMethodCallee);
              pJPopupMenu.add(miNext);
              }
              Vector vFunctions = _pJacob.getFunctions();
              if (vFunctions.size() > 0) {
              pJPopupMenu.add(new JSeparator());
              }
              for(Enumeration eFunctions = vFunctions.elements(); eFunctions.hasMoreElements(); ) {
              String sNextFunction = (String)eFunctions.nextElement();
              JMenuItem miNext = new JMenuItem(sNextFunction);
              miNext.addActionListener(this);
              pJPopupMenu.add(miNext);
              }
              
              pJPopupMenu.show(pMouseEvent_.getComponent(),
              pMouseEvent_.getX(), pMouseEvent_.getY());*/
        }
            
        //HighlightableItem pHighlightableItem = null;
        if (oSource == _lstPackages) {
            //pHighlightableItem = 
            //       (HighlightableItem)_lstPackages.getSelectedValue();
            //pHighlightableItem.setHighlightable( true );            
            _pJacob.showClasses();
            _pJacob.showMethods();
        } else if (oSource == _lstClasses) {
            //pHighlightableItem = 
            //       (HighlightableItem)_lstClasses.getSelectedValue();
            //pHighlightableItem.setHighlightable( true );            
            Util.debug( "mouseReleased(..).LST_CLASSES" );
            _pJacob.showMethods();
            _pJacob.editClass();
        } else if (oSource == _lstMethods) {
            String sMethod = null;
            if (_lstMethods.getSelectedIndex() != -1) {
                sMethod = _lstMethods.getSelectedValue().toString();
            }
            if (Util.isEmpty(sMethod)) {
                return;
            } else if (sMethod.equals(S_PARSE)) {
                _pJacob.parse();
                _pJacob.showMethods();
            } else {
                //pHighlightableItem = 
                //       (HighlightableItem)_lstMethods.getSelectedValue();
                //pHighlightableItem.setHighlightable( true );            
                _pJacob.editMethod(sMethod);
            }
        } else {
            // it must come from the Method Callees list
            if (_thrMenu == null) {
                _thrMenu = new EditMethodCallee(_pMethodCalleesDialog.getSelectedMethod());
                interrupt();
            }
        }
    }
    
    public void mousePressed(MouseEvent pMouseEvent_) {
        Util.debug("Controller.mousePressed(..).pMouseEvent_: " + pMouseEvent_);
        
    }
    
    // Test Funktionen --------------------------------------------------------------

    public Jacob getJacob() {
        return _pJacob;
    }

    /**
     * @deprecation   Use getJacob() instead. We changed policy and got more liberal (we means me).
     */
    public void getJacob(Test pTest_) {
        Util.panicIf(pTest_ == null);
        pTest_.setValue(_pJacob);
    }

    public void setEnabledGoBack( boolean bEnabled_ ) {
        Util.panicIf( _miGoBack == null );

        _miGoBack.setEnabled( bEnabled_ );
    }

    public void setEnabledGoForward( boolean bEnabled_ ) {
        Util.panicIf( _miGoForward == null );

        _miGoForward.setEnabled( bEnabled_ );
    }

    private JMenu _getEditMenu() {
        JMenuBar pMenuBar = getJMenuBar();

        // get edit menu
        JMenu mEdit = pMenuBar.getMenu( 1 );
        
        return mEdit;
    }

    private JMenuItem _getGoBackMenuItem() {
        JMenu mEdit = _getEditMenu();
        JMenuItem miGoBack = mEdit.getItem( 0 );
        Util.debug( "Controller._getGoBackMenuItem().miGoBack: " +
                    miGoBack );

        return miGoBack;
    }

    private JMenuItem _getGoForwardMenuItem() {
        JMenu mEdit = _getEditMenu();
        JMenuItem miGoForward = mEdit.getItem( 1 );

        return miGoForward;
    }

    public void startBusy()
    {
        BusyWindow.start( this );
    }

    public void stopBusy()
    {
        BusyWindow.stop();
    }

    class PopupListener extends MouseAdapter {
	public void mousePressed(MouseEvent e) {
	    maybeShowPopup(e);
	}
	
	public void mouseReleased(MouseEvent e) {
	    maybeShowPopup(e);
	}
	
	private void maybeShowPopup(MouseEvent e) {
	    if (e.isPopupTrigger()) {
		if ( _lstClasses.getSelectedIndex() != -1 ) {
		    _pPopupMenu.show(e.getComponent(),
				     e.getX(), e.getY());
		}
	    }
	}
    }
}
