/*
Copyright (C) 2000 Chr. Clemens Lee <clemens@kclee.com>.

This file is part of Jacob - The Java Commando Base
(http://www.kclee.com/clemens/jacob/).

Jacob is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

Jacob is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Jacob; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

package jacob;

import ccl.util.*;

/**
 * Program: Jacob
 *
 * @author Chr. Clemens Lee
 * @version $Id: Main.java 34.120 2002/05/04 09:03:58 clemens Exp clemens $
 */
public class Main {
    private static Controller _pController = null;

    /**
     * For testing purposes (BeanShell).
     */
    public static Controller getController() {
        return _pController;
    }

    public static void main(String[] argv) {
        // save original security manager
        SecurityManager originalManager = System.getSecurityManager();
        System.setSecurityManager( new JacobSecurityManager() );
        _pController = new Controller
               (argv,
                "$Header: /home/clemens/src/java/jacob/src/jacob/RCS/Main.java 34.120 2002/05/04 09:03:58 clemens Exp clemens $");
        // waits until exit
        Util.debug("Main.main(..).1");
        _pController.start();
        Util.debug("Main.main(..).2");
        _pController.dispose();
        Util.debug("Main.main(..).3");

        System.setSecurityManager( originalManager );
        
        System.exit(0);
    }
}
