/*
Copyright (C) 2001 Chr. Clemens Lee <clemens@kclee.com>.

This file is part of Jacob - The Java Commando Base
(http://www.kclee.com/clemens/jacob/).

Jacob is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

Jacob is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Jacob; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

package jacob.test;

import ccl.util.Test;
import ccl.util.Util;
import jacob.AddFieldDialog;
import jacob.CodeGenerator;
import jacob.Package;
import javax.swing.JFrame;

/**
 * Insert your test code into the _doIt() method and
 * test bugs with 'bugIf( boolean expression );' or
 * 'bugIf( boolean expression, "comment about what went wrong" );'.
 * Then just invoke the main routine.
 *
 * @version $Id: AddFieldDialogTest.java,v 1.3 2001/08/05 10:07:54 clemens Exp clemens $
 * @author  Chr. Clemens Lee
 */
public class AddFieldDialogTest extends Test {
    public AddFieldDialogTest() {
        super();
    }

    public AddFieldDialogTest( Test pTest_ ) {
        super( pTest_ );
    }

    private void _checkDialog()
        throws Exception
    {
        JFrame frmMain = new JFrame( "AddFieldDialog Test" );
        frmMain.setSize( 600, 400 );
        frmMain.setVisible( true );
        //Util.setDebug( true );
        Package.setClassPath( "/home/clemens/src/java/jacob/src" );
        Package pPackage = new Package( "jacob", true, true );
        AddFieldDialog dialog = new AddFieldDialog( frmMain, pPackage, "jacob.Controller" );
        dialog.show();
        dialog.dispose();
    }

    private void _checkCodeGeneration() {
        assert( CodeGenerator.stripVariablePrefix( "_sMainClass" ).equals( "MainClass" ) );
        assert( CodeGenerator.stripVariablePrefix( "_pckMain" ).equals( "Main" ) );
        assert( CodeGenerator.stripVariablePrefix( "dataCount" ).equals( "dataCount" ) );
        assert( Util.firstCharToUpperCase( "dataCount" ).equals( "DataCount" ) );
    }

    /**
     * Insert your test code into the _doIt() method and
     * test bugs with 'bugIf( boolean expression );' or
     * 'bugIf( boolean expression, "comment about what went wrong" );'.
     * Then just invoke the main routine.
     */
    protected void _doIt()
        throws Exception
    {
        _checkCodeGeneration();
        _checkDialog();
    }

    public static void main( String[] asArg_ ) {
        Test pTest = (Test)(new AddFieldDialogTest());
        pTest.setVerbose( true );
        pTest.run();
        pTest.printResult( pTest );

        System.exit( 0 );
    }
}
