/*
Copyright (C) 2001 Chr. Clemens Lee <clemens@kclee.com>.

This file is part of Jacob - The Java Commando Base
(http://www.kclee.com/clemens/java/javancss/).

Jacob is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

Jacob is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Jacob; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

package jacob.test;

import ccl.platform.Native;
import ccl.util.Test;
import ccl.util.Util;
import jacob.Controller;
import java.awt.Rectangle;
import java.awt.Point;
import javax.swing.JFrame;

/**
 * Insert your test code into the _doIt() method and
 * test bugs with 'bugIf( boolean expression );' or
 * 'bugIf( boolean expression, "comment about what went wrong" );'.
 * Then just invoke the main routine.
 *
 * @version $Id: ControllerTest.java,v 1.2 2001/07/30 22:08:23 clemens Exp clemens $
 * @author  Chr. Clemens Lee
 */
public class ControllerTest extends Test {
    public ControllerTest() {
        super();
    }

    public ControllerTest( Test pTest_ ) {
        super( pTest_ );
    }

    protected void _doIt()
        throws Exception
    {
        JFrame frame = new JFrame( "test" );
        frame.setBounds( 598, 0, 202, 600 );
        frame.show();
        Thread.currentThread().sleep( 3*1000 );
        Native n = Native.getInstance();
        n.setLocation( frame, 598, 0 );
        Thread.currentThread().sleep( 3*1000 );
        //gIf( !frame.getBounds().equals( new Rectangle( 598, 0, 202, 600 ) )
        //      , "Frame position should be 598,0-202x600 but is: " + frame.getBounds() );
        bugIf( !frame.getLocation().equals( new Point( 598, 0 ) )
                , "Frame location should be 598,0 but is: " + frame.getLocation() );
        frame.dispose();
    }

    public static void main( String[] asArg_ ) {
        Test pTest = (Test)(new ControllerTest());
        pTest.setVerbose( true );
        pTest.run();
        pTest.printResult( pTest );

        System.exit( 0 );
    }
}
