/*
Copyright (C) 2000 Chr. Clemens Lee <clemens@kclee.com>.

This file is part of Jacob - The Java Commando Base
(http://www.kclee.com/clemens/java/javancss/).

Jacob is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

Jacob is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Jacob; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

package jacob.test;

import ccl.platform.Native;
import ccl.swing.SwingUtil;
import ccl.util.FileUtil;
import ccl.util.History;
import ccl.util.Test;
import ccl.util.Util;
import ccl.util.test.UtilTest;
import jacob.Controller;
import jacob.Jacob;
import jacob.JacobConstants;
import jacob.Package;
import jacob.tool.JavancssAll;
import jacob.tool.JavancssSelected;
import jacob.tool.test.ApplicationWizardTest;
import java.awt.Dialog;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;
import java.io.File;
import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import javancss.JavancssFrame;
import javax.swing.DefaultListModel;
import javax.swing.JList;

/**
 * With version 28 saving a standard tutorial project,
 * then opening a temporary project, saving the temp
 * project, and opening with File->Tutorial the tutorial
 * again, has the jacob.tutorial package in the remove
 * dialog, but not in the packages list.
 * This is a bug this method wants to reproduce.
 *
 * $Id: OldFilesTest.java,v 1.1 2001/02/04 14:06:02 clemens Exp clemens $
 */
public class OldFilesTest extends    JacobTest 
                          implements JacobConstants
{
    public OldFilesTest() {
        super();
    }
    
    public OldFilesTest(Test pTest_) {
        super(pTest_);
    }

    /**
     * With version 28 saving a standard tutorial project,
     * then opening a temporary project, saving the temp
     * project, and opening with File->Tutorial the tutorial
     * again, has the jacob.tutorial package in the remove
     * dialog, but not in the packages list.
     * This is a bug this method wants to reproduce.
     */
    private void _doOldFilesTest() {
        // open jacob with new tutorial project
        String sTutorialProject = null;
        {
            // get tutorial project file name
            sTutorialProject = deleteProjectFile( "tutorial" );

            openJacob( sTutorialProject );
        }

        // add jacob.tutorial package
        {
            // set sourcepath
            String sSourcePath = FileUtil.concatPath( FileUtil.getApplicationHome( this )
                                                      , "src" );
            Package.setSourcePath( sSourcePath );

            //addPackage
            addPackage( "jacob.tutorial" );
        }

        // save
        getJacob().save();

        assertPackagesListSize( 1 );

        // open new temp project
        getJacob().openProject( deleteProjectFile( "temp" ) );
        // save
        getJacob().save();
        Util.sleep( 3 );
        assertPackagesListSize( 0 );

        // open back tutorial again
        getJacob().openProject( sTutorialProject );

        // check for appearance of jacob.tutorial in package
        Util.sleep( 3 );
        assertPackagesListSize( 1 );
        

        // close jacob
        closeJacob();
    }

    protected void _doIt() 
        throws Exception
    {
        _doOldFilesTest();
    }

    public String toString() {
        return "Old Files Test";
    }

    public static void main(String[] args) {
        Test pTest = (Test)(new OldFilesTest());
        pTest.setTiming( true );
        pTest.run();
        pTest.printResult(pTest);

        System.exit(0);
    }
}
