/*
Copyright (C) 2000 Chr. Clemens Lee <clemens@kclee.com>.

This file is part of Jacob - The Java Commando Base
(http://www.kclee.com/clemens/java/javancss/).

Jacob is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

Jacob is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Jacob; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

package jacob.tool;

import java.util.*;

import jacob.JavaClass;
import jacob.Package;

import ccl.util.*;

import javancss.*;

/**
 * Example wrapper class for JavaNCSS.
 * 
 * @author  <a href="http://mats.gmd.de/clemens/">Chr. Clemens Lahme</a> (<a href="mailto:clemens.lahme@mailexcite.com"><i>Clemens.Lahme@mailexcite.com</i></a>)
 * @version $Id: JavancssAll.java,v 1.6 2001/08/05 10:08:01 clemens Exp clemens $
 * @see JavancssSelected
 */
public class JavancssAll extends JavancssSelected {
    /**
     * Communicates with JavancssSelected via _vAllClasses.
     * This method gets invoked from JavancssSelected.run().
     */
    protected void _setAllClasses() {
        // get Vector with source and compile classen
        Package pckMain = _pJacobInterface.getMainPackage();
        _vAllClasses = new Vector();
        Enumeration enJavaClasses = pckMain.getClassElements();
        while ( enJavaClasses.hasMoreElements() ) {
            JavaClass jclNext = (JavaClass)enJavaClasses.nextElement();
            String sFullName = jclNext.getSourceFullFileName();
            _vAllClasses.addElement( sFullName );
        }        
    }
    
    public JavancssAll() {
        super();
    }
}
