/*
Copyright (C) 2000 Chr. Clemens Lee <clemens@kclee.com>.

This file is part of Jacob - The Java Commando Base
(http://www.kclee.com/clemens/java/javancss/).

Jacob is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

Jacob is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Jacob; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

package jacob.tool;

import ccl.util.Util;

import jacob.tool.JacobInterface;
import jacob.tool.JacobRunnable;

/**
 * This class exists just for convenience
 * reasons.
 * 
 * @author  <a href="http://mats.gmd.de/clemens/">Chr. Clemens Lahme</a> (<a href="mailto:clemens.lahme@mailexcite.com"><i>Clemens.Lahme@mailexcite.com</i></a>)
 * @version $Id: WrapperAdapter.java,v 1.4 2000/07/30 15:32:53 clemens Exp clemens $
 */
public abstract class WrapperAdapter implements JacobRunnable {
    protected JacobInterface _pJacobInterface = null;

    public WrapperAdapter() {
        super();
    }

    /*
     * --- implemented methods of class 'jacob.tool.JacobRunnable' ---
     */
    
    public void set(JacobInterface pJacobInterface_) {
        Util.panicIf(pJacobInterface_ == null);
        _pJacobInterface = pJacobInterface_;
    }
    
    public String toString() {
        String sRetVal = getClass().getName();
        sRetVal = sRetVal.substring(sRetVal.lastIndexOf('.') + 1);
        if (Util.endsWith(sRetVal, "Wrapper")) {
            sRetVal = sRetVal.substring(0, sRetVal.length() - 7);
        }
        
        return sRetVal;
    }
    
    public void run() {
        // just in case someone does extend this
        // class but does not override this
        // method, so it gets stopped.
        _pJacobInterface.stopped(this);
    }
}
